"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnsupportedExtension = exports.getPackageJson = exports.buildDebugger = exports.withDuration = void 0;
const debug_1 = require("debug");
const pkg = Promise.resolve().then(() => require("../package.json"));
// eslint-disable-next-line @typescript-eslint/ban-types
function withDuration(fn, args, log) {
    const startedAt = Date.now();
    const result = fn(...args);
    const endedAt = Date.now();
    log(`duration: ${endedAt - startedAt}ms`);
    return result;
}
exports.withDuration = withDuration;
function buildDebugger(module) {
    const name = "code-complexity";
    return name ? (0, debug_1.default)(`${name}:${module}`) : (0, debug_1.default)(name);
}
exports.buildDebugger = buildDebugger;
async function getPackageJson() {
    const { description, name, version } = pkg;
    return { description, name, version };
}
exports.getPackageJson = getPackageJson;
class UnsupportedExtension {
}
exports.UnsupportedExtension = UnsupportedExtension;
